using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class MessageBox
{
    private static System.Collections.Hashtable m_executingPages = new System.Collections.Hashtable();
    private MessageBox() { }
    public static void Show(string sMessage)
    {
        // If this is the first time a page has called this method then
        if (!m_executingPages.Contains(HttpContext.Current.Handler))
        {
            Page executingPage = HttpContext.Current.Handler as Page;
            if (executingPage != null)
            {
                System.Collections.Queue messageQueue = new System.Collections.Queue();
                messageQueue.Enqueue(sMessage);
                m_executingPages.Add(HttpContext.Current.Handler, messageQueue);
                executingPage.Unload += new EventHandler(ExecutingPage_Unload);
            }
        }
        else
        {
            System.Collections.Queue queue = (System.Collections.Queue)m_executingPages[HttpContext.Current.Handler];
            queue.Enqueue(sMessage);
        }
    }

    private static void ExecutingPage_Unload(object sender, EventArgs e)
    {
        System.Collections.Queue queue = (System.Collections.Queue)m_executingPages[HttpContext.Current.Handler];
        if (queue != null)
        {
            StringBuilder sb = new StringBuilder();
            int iMsgCount = queue.Count;
            sb.Append("<script language='javascript'>");
            string sMsg;
            while (iMsgCount-- > 0)
            {
                sMsg = (string)queue.Dequeue();
                sMsg = sMsg.Replace("\n", "\\n");
                sMsg = sMsg.Replace("\"", "'");
                sb.Append(@"alert( """ + sMsg + @""" );");
            }
            sb.Append(@"</script>");
            m_executingPages.Remove(HttpContext.Current.Handler);
            HttpContext.Current.Response.Write(sb.ToString());
        }
    }
}

