using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class MasterPage : System.Web.UI.MasterPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        User user = (User)Session["User"];

        TextBox_Login.Focus();
        if (Session["User"] != null)
        {
            user = (User)Session["User"];
            Panel_LogIn.Visible = false;
            Panel_LoggedIn.Visible = true;
            Label_LoggedInText.Text = user.Login + ", vitaj v aplikcii tmu<br />Ninja Team 3000";
            
        }
        else
        {
            Panel_LogIn.Visible = true;
            Panel_LoggedIn.Visible = false;
        }

        if (user != null)
        {
            string sql = "Update Online SET PostBack = GetDate() WHERE Login = '" + user.Login + "'";
            Utils.SqlExecute(sql);
        }

        if(user == null)
            GenerateMenu(3);
        else
            GenerateMenu(user.Function);

        string sqlselect = "SELECT * FROM Online";
        DataTable online = Utils.SqlConnection("SELECT * FROM Online");
        foreach(DataRow row in online.Select())
        {
            TimeSpan rozdiel = (DateTime.Now - Convert.ToDateTime(row["PostBack"].ToString()));
            if (rozdiel >= new TimeSpan(0, 20, 0))
            {
                string sql = "DELETE FROM Online WHERE Login = '" + row["Login"].ToString() + "'";
                Utils.SqlExecute(sql);
            }
        }

        Label_OnlineCount.Text = Convert.ToString((Utils.SqlConnection(sqlselect)).Rows.Count);

        Label_ExecCount.Text = Convert.ToString((Utils.SqlConnectionAlchemi("SELECT * FROM executor WHERE is_connected = 1")).Rows.Count);

        if (user != null)
        {
            online = Utils.SqlConnection("SELECT * FROM Online WHERE Login = '" + user.Login + "'");
            if (online.Rows.Count == 0)
            {
                Session["User"] = null;
                Response.Redirect("~/Default.aspx", false);
            }
        }

        LabelTime.Text = DateTime.Now.ToLongTimeString();
        LabelDate.Text = DateTime.Now.ToShortDateString();
    }

    protected void Button_Login_Click(object sender, EventArgs e)
    {
        DataRow[] dr = null;
        if (CustomAuthenticate(TextBox_Login.Text, TextBox_Password.Text, out dr))
        {
            string url = FormsAuthentication.GetRedirectUrl(TextBox_Login.Text, false);

            FormsAuthentication.SetAuthCookie(TextBox_Login.Text, false);

            Session.Remove("User");
            Session.Add("User", new User(TextBox_Login.Text, dr[0]["E-mail"].ToString(), (int)dr[0]["IdFunction"]));

            string sql = "INSERT INTO Online VALUES('" + TextBox_Login.Text + "', GetDate())";
            Utils.SqlExecute(sql);

            Response.Redirect("~\\Pages\\Main.aspx");
        }
    }

    private bool CustomAuthenticate(string loginName, string password, out DataRow[] dr)
    {
        DataTable login = (DataTable)Application["dt_login"];
        dr = login.Select("Nickname = '" + loginName + "' AND Password = '" + DBConn.DeCode(password) + "'");
        if (dr.Length == 0) return false;

        DataTable online = Utils.SqlConnection("SELECT * FROM Online WHERE Login = '" + loginName + "'");
        if (online.Rows.Count > 0)
        {
            TimeSpan rozdiel = (DateTime.Now - Convert.ToDateTime(online.Rows[0]["PostBack"].ToString()));
            if (rozdiel < new TimeSpan(0, 20, 0))
            {
                Utils.AjaxMessageBox(this, "Dan uvate je u prihlsen");
                return false;
            }
            else
            {
                string sql = "DELETE FROM Online WHERE Login = '" + loginName + "'";
                Utils.SqlExecute(sql);
            }
        }
        return true;
    }

    protected void Button_Registration_Click(object sender, EventArgs e)
    {
        Response.Redirect("~/Registration.aspx", false);
    }

    protected void LinkButton_LogOut_Click(object sender, EventArgs e)
    {
        FormsAuthentication.SignOut();

        string sql = "DELETE FROM Online WHERE Login = '" + ((User)Session["User"]).Login + "'";
        Utils.SqlExecute(sql);
        
        Session["User"] = null;
        Response.Redirect("~/Default.aspx", false);
    }

    private void GenerateMenu(int function)
    {
        Menu1.Items.Clear();
        switch (function)
        {
            case 0:
                Menu1.Items.Add(new MenuItem("Domovsk strnka", "", "", "~/Default.aspx"));
                Menu1.Items.Add(new MenuItem("Zmena registrcie", "", "", "~/Pages/ChangeRegistration.aspx"));
                Menu1.Items.Add(new MenuItem("Na stiahnutie", "", "", "~/Pages/Downloads.aspx"));
                Menu1.Items.Add(new MenuItem("Faktorizcia", "", "", "~/Pages/Factorization.aspx"));
                Menu1.Items.Add(new MenuItem("Sprva uvateov", "", "", "~/Pages/RegistrationAdmin.aspx"));
                Menu1.Items.Add(new MenuItem("Online uvatelia", "", "", "~/Pages/OnlineUsers.aspx"));
                break;
            case 1:
                Menu1.Items.Add(new MenuItem("Domovsk strnka", "", "", "~/Default.aspx"));
                Menu1.Items.Add(new MenuItem("Zmena registrcie", "", "", "~/Pages/ChangeRegistration.aspx"));
                Menu1.Items.Add(new MenuItem("Na stiahnutie", "", "", "~/Pages/Downloads.aspx"));
                Menu1.Items.Add(new MenuItem("Faktorizcia", "", "", "~/Pages/Factorization.aspx"));
                break;
            case 2:
                Menu1.Items.Add(new MenuItem("Domovsk strnka", "", "", "~/Default.aspx"));
                Menu1.Items.Add(new MenuItem("Zmena registrcie", "", "", "~/Pages/ChangeRegistration.aspx"));
                Menu1.Items.Add(new MenuItem("Na stiahnutie", "", "", "~/Pages/Downloads.aspx"));
                break;
            case 3:
                Menu1.Items.Add(new MenuItem("Domovsks strnka", "", "", "~/Default.aspx"));
                Menu1.Items.Add(new MenuItem("Zmena registrcie", "", "", "~/Pages/ChangeRegistration.aspx"));
                Menu1.Items.Add(new MenuItem("Na stiahnutie", "", "", "~/Pages/Downloads.aspx"));
                break;
            default:
                break;
        }
    }
}
