using System;
using System.Data;
using System.Configuration;
using System.Runtime.InteropServices;
using System.Collections;
using System.Web;
using System.Net;
using System.Text;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Alchemi.Core;
using Alchemi.Core.Owner;
using Alchemi.Core.Utility;
using log4net;
using System.Threading;
using System.Net.Sockets;
using Libsy;

public partial class Factorization : System.Web.UI.Page
{

    Thread progressThread;
    bool status;
    string progress;
    bool started;
    Socket sck;
    string number;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        sck = (Socket)Application["socket"]; 

        if (Session["progress"] == null)
            Session["progress"] = progress;
        else
            progress = (string)Session["progress"];

        if (Session["started"] == null)
            Session["started"] = started;
        else
            started = (bool)Session["started"];

        if (Session["status"] == null)
            Session["status"] = status;
        else
            status = (bool)Session["status"];

        if (Session["number"] == null)
            Session["number"] = number;
        else
            number = (string)Session["number"];

        if (!IsPostBack)
        {
            progressThread = new Thread(new ThreadStart(ListenForProgress));
            progressThread.Start();
            Button_Stop.Visible = false;
        }

        TextBox_Debug.Text = progress;
        ScriptManager.RegisterStartupScript(TextBox_Debug, typeof(TextBox), "scrolltext", "scroll('" + TextBox_Debug.ClientID + "');", true);
        Visibility();
    }

    //[STAThread]
    //private void Start()
    //{
    //    ulong threadcount = 10;
    //    Statical.progress.Remove(0, Statical.progress.Length);
    //    try
    //    {
    //        Statical.max = new BigInteger(TextBox_NumberToFactorize.Text, 10);
    //        threadcount = Convert.ToUInt64(TextBox_ExecutorsCount.Text);
    //    }
    //    catch
    //    {
    //    }

    //    try
    //    {
    //        Statical.StartGrid(threadcount);
    //        ScriptManager.RegisterStartupScript(this, this.GetType(), "PostBack", "__doPostBack('" + TextBox_ExecutorsCount.ClientID + "','');", true);
    //    }
    //    catch (Exception e)
    //    {
    //        Statical.started = false;
    //        Statical.progress.AppendLine("ERROR: " + e.StackTrace);
    //        Statical.changed = true;
    //    }
    //}

    protected void Button_Start_Click(object sender, EventArgs e)
    {
        Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        number = TextBox_NumberToFactorize.Text;
        Session["number"] = number;

        try
        {
            socket.Connect(new IPAddress(new byte[] { 127, 0, 0, 1 }), 8000);
            byte[] temp = Encoding.ASCII.GetBytes(TextBox_NumberToFactorize.Text + " " + TextBox_ExecutorsCount.Text);
            byte[] flag = new byte[temp.Length + 1];
            temp.CopyTo(flag, 1);
            socket.Send(flag);
            byte[] buffer = new Byte[1024];
            progress = Encoding.Unicode.GetString(buffer);
            Session["progress"] = progress;
        }
        finally
        {
            socket.Close();
        }
    }

    protected void Button_Stop_Click(object sender, EventArgs e)
    {
        Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

        if (progressThread != null)
            progressThread.Abort();

        try
        {
            socket.Connect(new IPAddress(new byte[] { 127, 0, 0, 1 }), 8000);
            byte[] flag = new Byte[] { 2 };
            socket.Send(flag);
            byte[] buffer = new Byte[1024];
            if (socket.Receive(buffer) <= 0)
            {
                progress = "Momentalne neprebieha ziaden vypocet";
                Session["progress"] = progress;
                return;
            }
            progress = Encoding.Unicode.GetString(buffer);
            Session["progress"] = progress;
        }
        finally
        {
            socket.Close();
        }
    }

    private void Visibility()
    {
        if (status == started)
            return;

        if (started)
        {
            status = started;
            Session["status"] = status;
            Label_Max.Text = number;
            Panel_Stopped.Visible = false;
            Panel_Started.Visible = true;
            Button_Start.Visible = false;
            Button_Stop.Visible = true;
        }
        else 
        {
            status = started;
            Session["status"] = status;
            Panel_Started.Visible = false;
            Panel_Stopped.Visible = true;
            Button_Start.Visible = true;
            Button_Stop.Visible = false;
        }
        UpdatePanel3.Update();
        UpdatePanel1.Update();
    }

    public void ListenForProgress()
    {
        try
        {
            while (true)
            {
                byte[] buffer = new Byte[65535];
                int length = sck.Receive(buffer);
                if (length <= 0)
                {

                    //progress = Encoding.ASCII.GetString(buffer, 0, buffer.Length);
                    progress = "Momentalne neprebieha ziaden vypocet";
                    Session["progress"] = progress;
                    continue;
                }
                //Invoke(new UpdateDisplayDelegate(UpdateTextBox), );
                string[] message = Encoding.Default.GetString(buffer, 0, length).Split('@');
                progress = message[0];
                started = Convert.ToBoolean(message[1]);
                number = message[2];
                Session["progress"] = progress;
                Session["started"] = started;
                Session["number"] = number;
            }
        }
        catch (SocketException ex)
        {
            progress = ex.ToString(); return;
        }
        finally
        {

            sck.Close();
        }
    }
}
